<template>
  <v-row no-gutters>
    <v-col style="background: #f0f1f6">
      <!-- <v-img src="/images/whitebg.jpg" height="100vh"> -->
      <v-container fill-height>
        <v-row justify="center">
          <v-col cols="12" align-self="center">
            <div class="title">
              <h1>Bienvenido, {{ user ? user.sub : '' }}</h1>
              <h4>Selecciona el rol con el que desea ingresar</h4>
            </div>
            <div class="content-role">
              <v-card
                v-for="(role, idx) in filterRoles"
                :key="idx"
                width="180"
                height="180"
                class="card-role"
                elevation="5"
                color="#EAFCEF"
                @click="setRole(role)"
              >
                <v-card-text>
                  <v-img width="100" :src="role.image" class="mx-auto" />
                  <div class="subtitle-1 title-role">
                    {{ role.title }}
                  </div>
                </v-card-text>
              </v-card>
            </div>
          </v-col>
        </v-row>
        <v-row no-gutters justify="end">
        <v-btn text @click="logout">
          <v-icon>mdi-logout</v-icon>
         cerrar sesión</v-btn>
        </v-row>
      </v-container>
      <!-- </v-img> -->
    </v-col>
  </v-row>
</template>
<script>
import { mapActions, mapState } from "vuex";
import rolesinfo from "@/assets/js/rolesinfo.js";
import userTypes from "@/assets/js/users"

export default {
  layout: 'simple',
  middleware: 'auth',
  data() {
    return {
      roles: rolesinfo,
    };
  },
  computed: {
    ...mapState({
      user: state => state.auth.user,
    }),
    filterRoles() {
      let filteredRoles = [];
      for (let index in userTypes) {
        const { id, name } = userTypes[index]
        const username = this.user ? this.user[name] : ''
         if (username) {
          const objrole = this.roles.find((obj) => obj.id === id);
          if (objrole.id === userTypes.client_supervisor.id) objrole.title = `Supervisor ${this.user.cs_com}`
          if (objrole.id === userTypes.prov_supervidor.id) objrole.title = `Supervisor ${this.user.ps_com}`
          filteredRoles.push(objrole);
        }
      }
      return filteredRoles;
    },
  },
  methods: {
    setRole(selectedRole) {
      const options = selectedRole.options;
      const id = selectedRole.id; //0,1,2,3,4
      this.setRoleState({ options, role: id });
      if (id === userTypes.patient.id || id === userTypes.specialist.id) {
        window.location = `${selectedRole.route}`;
      } else {
        window.location = `${this.$config.ctBackofficeUrl}${selectedRole.route}`;
      }
    },
    logout() {
      this.logoutState()
      this.$router.push('/')
    },
    ...mapActions({
      setRoleState: 'roles/loginRole',
      logoutState: "auth/logout",
    }),
  },
};
</script>
<style lang="scss" scoped>
.title {
  margin-bottom: 50px;
  text-align: center;
  h1 {
    margin-bottom: 20px;
  }
  h4 {
    font-weight: 400;
  }
}
.content-role {
  display: flex;
  justify-content: center;
  flex-wrap: wrap;
}
.card-role {
  margin: 10px;
  display: flex;
  align-items: center;
  text-align: center;
  cursor: pointer;
}
.title-role {
  color: #444;
  margin-top: 8px;
  font-weight: 500;
}
</style>
